# Permission to use, copy, modify, and distribute this software for
# any purpose and without fee is hereby granted.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

  require('extensions.rb')

  module Fishelzon  # Proprietary TopLevel Namespace: No Tresspassing!

    class FishelzonLoader

      def loadLastVer( m_name, m_description )
        # Create an entry in the Extension list that loads
        #  a script called: "Fishelzon\#{m_name}VerX.X.X.rb"
        @@fileDir   = Dir.entries(File.dirname(__FILE__) + "/Fishelzon")
        @@fileDir   = @@fileDir.delete_if {|item| not item[/#{m_name}/] }
        @@maxVerNum = 0
        @@maxVer    = ""
        for i in 0..(@@fileDir.length - 1)
          @@fileVer = @@fileDir[i].split("Ver")[1].chomp('.rb').split('.')
          @@fileVer = @@fileVer.map {|elm| "%03d" % elm.to_i }
          if @@maxVer    < @@fileVer.join
             @@maxVerNum = i 
             @@maxVer    = @@fileVer.join 
          end # if @@maxVer < @@fileVer.join
        end #for i
        @@thisFile = "Fishelzon/" + @@fileDir.sort[@@maxVerNum]

        @@plugin = SketchupExtension.new( "Fishelzon's #{m_name} ", @@thisFile )
       
        @@plugin.creator     = 'Fishelzon David'
        @@plugin.copyright   = "(c)2013 by Fishelzon David"
        @@plugin.version     = @@thisFile.split("Ver")[1].chomp('.rb')
        @@plugin.description = m_description

        # Register this extension with the Sketchup::ExtensionManager
        Sketchup.register_extension( @@plugin, true )
        
        #return @@thisFile
      end # def loadLastVer

    end # class FishelzonLoader

    FishelzonLoader.new.loadLastVer( "GcodeImporter" , 
      "This G code Importer allows importing a 3D printers G-Code to   the SketchUp 3D modeling environment. " )

    FishelzonLoader.new.loadLastVer( "GcodeExporter" , 
      "This G code Exporter allows exporting a 3D printers G-Code from the SketchUp 3D modeling environment. " )

  end # module Fishelzon
